interface SafeCallable<T> {
    (): T | undefined;
    <K>(fallback: K): T extends undefined ? K : K | T;
}
declare type SafeProps<T> = {
    readonly [P in keyof T]-?: SafeTouch<T[P]>;
};
declare type Safe<T> = SafeProps<T> & SafeCallable<T>;
declare type SafeTouch<T> = T extends undefined | number | boolean ? SafeProps<any> & SafeCallable<undefined> : Safe<T>;
declare function touch(source?: undefined): SafeTouch<any>;
declare function touch<T>(source: T): SafeTouch<T>;
export declare const safeTouch: typeof touch;
export default touch;
